package Mergesort;

public class Mergesort {
	private int x[], tmp[];
	
	private void merge(int left, int middle, int right)
	{
		for (int i = left; i<=right; ++i)
			tmp[i] = x[i];
		
		int l = left;
		int r = middle + 1;
		int pos = left;
		
		// traverse until either at end of left or right side
		while (l <= middle && r <= right)
		{
			if (tmp[l] <= tmp[r]){
				x[pos] = tmp[l];
				++l;
			}
			else
			{
				x[pos] = tmp[r];
				++r;
			}
			++pos;
		}
		// if l < middle: copy remaining elements from left side to target array
		// if r < right: already copied above
		while (l <= middle)
		{
			x[pos] = tmp[l];
			++l; ++pos;
		}
	}
	
	// split and recursively merge
	private void mergesort(int left, int right)
	{
		if (left < right){
			int middle = (left + right) / 2;
			mergesort(left, middle);
			mergesort(middle+1, right);
			merge(left, middle, right);
		}
	}
	
	// driver
	public void Sort(int[] X)
	{
		x = X;
		tmp = new int[X.length];
		mergesort(0, x.length-1);
	}
}
